=== debian/changelog ===
signal-estimator (0.0.9-1) unstable; urgency=medium

  * Initial Debian release.
  * Add license of icons from Google Fonts, thanks to ftpmasters.

 -- Dylan Aïssi <daissi@debian.org>  Sat, 20 Jul 2024 10:11:55 +0200
