=== debian/control ===
Source: signal-estimator
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dylan Aïssi <daissi@debian.org>
Section: sound
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libasound2-dev,
               libcli11-dev,
               libconcurrentqueue-dev,
               libfmt-dev,
               libisptr-dev,
               libkissfft-dev,
               libpng-dev,
               libqwt-qt5-dev,
               libspdlog-dev,
               pkgconf,
               qtbase5-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/multimedia-team/signal-estimator
Vcs-Git: https://salsa.debian.org/multimedia-team/signal-estimator.git
Homepage: https://github.com/gavv/signal-estimator
Rules-Requires-Root: no

Package: signal-estimator
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: measure characteristics of a looped back signal
 signal-estimator is a small command-line and GUI tool allowing to measure
 different characteristics of the signal looped back from audio output to
 audio input. Its features are:
  - send test signal to output device and receive looped back signal from input
   device(s)
  - measure signal latency (the shift between output and input signal)
  - measure signal loss ratio (number of glitches per second in the input
   signal)
  - measure I/O jitter and delay
  - print reports in JSON format for easy parsing
  - dump output and input streams in CSV format for later inspection

Package: signal-estimator-gui
Architecture: any
Depends: signal-estimator,
         ${misc:Depends},
         ${shlibs:Depends}
Description: measure characteristics of a looped back signal (GUI)
 signal-estimator is a small command-line and GUI tool allowing to measure
 different characteristics of the signal looped back from audio output to
 audio input. Its features are:
  - send test signal to output device and receive looped back signal from input
   device(s)
  - measure signal latency (the shift between output and input signal)
  - measure signal loss ratio (number of glitches per second in the input
   signal)
  - measure I/O jitter and delay
  - print reports in JSON format for easy parsing
  - dump output and input streams in CSV format for later inspection
 .
 This package contains a simple GUI for signal-estimator.
