=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_CXXFLAGS_MAINT_APPEND = \
         -I/usr/include/concurrentqueue/moodycamel/ \
         -I/usr/include/kissfft/

%:
	dh $@ --buildsystem=cmake
