=== Makefile ===
--- 
+++ 
@@ -2,17 +2,23 @@
 VARIANT ?= Release
 WERROR ?= OFF
 SANITIZERS ?= OFF
+TESTS ?= ON
 
 MACHINE := $(shell uname -m)-linux-gnu
 
-CMAKE_CMD := cmake -DCMAKE_BUILD_TYPE=$(VARIANT) \
-	-DENABLE_WERROR=$(WERROR) -DENABLE_SANITIZERS=$(SANITIZERS)
+CMAKE_CMD := cmake \
+	-DCMAKE_BUILD_TYPE=$(VARIANT) \
+	-DBUILD_TESTING=$(TESTS) \
+	-DENABLE_WERROR=$(WERROR) \
+	-DENABLE_SANITIZERS=$(SANITIZERS)
+
 MAKE_CMD := make -j$(NUM_CPU) --no-print-directory
 
 DOCKER_CMD := docker run -t --rm \
 	-u "$(shell id -u)" \
 	-v "$(shell pwd):$(shell pwd)" \
-	-w "$(shell pwd)"
+	-w "$(shell pwd)" \
+	-e "CI=${CI}"
 
 all:
 	mkdir -p build/$(MACHINE)
@@ -23,6 +29,10 @@
 	mkdir -p build/$(MACHINE)
 	cd build/$(MACHINE) && $(CMAKE_CMD) -DBUILD_GUI=NO ../..
 	cd build/$(MACHINE) && $(MAKE_CMD)
+
+.PHONY: test
+test:
+	./bin/$(MACHINE)/signal-estimator-test
 
 arm32:
 	mkdir -p build/arm-linux-gnueabihf
