=== debian/changelog ===
signal-estimator (0.1.0-1) unstable; urgency=medium

  * New upstream version 0.1.0
  * Refresh patch
  * Build tests
  * Install signal-estimator-test
  * Use signal-estimator-test for autopkgtest

 -- Dylan Aïssi <daissi@debian.org>  Mon, 21 Oct 2024 14:07:29 +0200
