=== debian/control ===
--- 
+++ 
@@ -9,6 +9,8 @@
                libcli11-dev,
                libconcurrentqueue-dev,
                libfmt-dev,
+               libgmock-dev,
+               libgtest-dev,
                libisptr-dev,
                libkissfft-dev,
                libpng-dev,
