=== debian/watch ===
version=4
https://github.com/gavv/signal-estimator/tags .*/v?(\d.*)@ARCHIVE_EXT@
